<template>
  <div>
    <div class="text-right mb-3">
      <button class="btn btn-success mr-3" @click.prevent="load">
        Load Response
      </button>
    </div>
    <div class="row">
      <div class="col-12">
        <div class="table-responsive">
          <table
            class="table table-head-custom table-vertical-center table-head-bg table-borderless"
          >
            <thead>
              <tr>
                <th style="min-width: 100px;">Scope</th>
                <th style="min-width: 100px;">Tanggal Response</th>
                <th style="min-width: 100px;" class="text-center">Aksi</th>
              </tr>
            </thead>
            <template
              v-if="
                this.$store.getters.getterResponseChangeManagement.length == 0
              "
            >
              <tbody>
                <tr>
                  <template v-if="isLoading">
                    <td colspan="4" class="text-center">
                      <b-spinner variant="primary" label="Spinning"></b-spinner>
                    </td>
                  </template>
                  <template v-else>
                    <td colspan="3">
                      <div class="text-center">
                        <i
                          class="flaticon2-open-box text-secondary icon-3x"
                        ></i>

                        <h4>
                          Data kosong.
                        </h4>
                      </div>
                    </td>
                  </template>
                </tr>
              </tbody>
            </template>
            <template v-else>
              <tbody>
                <template
                  v-for="(item, i) in this.$store.getters
                    .getterResponseChangeManagement"
                >
                  <tr v-bind:key="i">
                    <td>{{ item.scope.name }}</td>
                    <td>
                      <template>
                        <div v-bind:id="'response-change-text-' + i">
                          {{ item.date == null ? "-" : item.date }}
                        </div>
                        <div
                          class="d-none"
                          v-bind:id="'response-change-form-' + i"
                        >
                          <input
                            type="date"
                            class="form-control"
                            v-model="edit.date"
                          />
                        </div>
                      </template>
                    </td>
                    <td class="text-center">
                      <template>
                        <div v-bind:id="'response-change-edit-' + i">
                          <a
                            class="btn btn-light-success"
                            @click.prevent="editResponseChange(i)"
                          >
                            <i class="flaticon-edit"></i>
                          </a>
                        </div>
                        <div
                          class="d-none"
                          v-bind:id="'response-change-save-' + i"
                        >
                          <a class="mr-3" @click.prevent="cancel(i)">
                            <i class="flaticon2-cross text-danger"></i>
                          </a>
                          <a
                            class="btn btn-primary"
                            @click.prevent="save(item, i)"
                          >
                            <i class="flaticon2-paperplane text-white"></i>
                          </a>
                        </div>
                      </template>
                    </td>
                  </tr>
                </template>
              </tbody>
            </template>
          </table>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import {
  GET_RESPONSE_CHANGE_MANAGEMENT,
  UPDATE_RESPONSE_CHANGE_MANAGEMENT
} from "@/core/services/store/change-management.module";

export default {
  name: "Response",
  data() {
    return {
      data: {
        response: [
          {
            scope: "HMI",
            date: "28-10-2021"
          },
          {
            scope: "TAN",
            date: "24-05-2021"
          }
        ]
      },
      edit: {
        date: ""
      },
      isLoading: false,
      isEdit: false
    };
  },
  methods: {
    editResponseChange(id) {
      var input = document.getElementById("response-change-form-" + id);
      var text = document.getElementById("response-change-text-" + id);

      if (this.isEdit == false) {
        input.classList.remove("d-none");
        text.classList.add("d-none");

        // button
        var edit = document.getElementById("response-change-edit-" + id);
        var save = document.getElementById("response-change-save-" + id);

        edit.classList.add("d-none");
        save.classList.remove("d-none");
        this.isEdit = true;
      } else {
        this.$bvToast.toast("Selesaikan edit data terlebih dahulu", {
          title: "Warning",
          variant: "warning",
          solid: true
        });
      }
    },

    async load() {
      this.isLoading = true;
      await this.$store.dispatch(GET_RESPONSE_CHANGE_MANAGEMENT, {
        id: this.$route.params.id_change_management
      });
      this.isLoading = false;
    },

    async save(item, i) {
      var date = this.edit.date;
      if (date == "") {
        this.$bvToast.toast("Tanggal harus diisi", {
          title: "Warning",
          variant: "warning",
          solid: true
        });
      } else {
        var split = date.split("-");
        var fix = split[2] + "-" + split[1] + "-" + split[0];
        var send = [{ id: item.id, date: fix }];

        await this.$store.dispatch(UPDATE_RESPONSE_CHANGE_MANAGEMENT, {
          id: this.$route.params.id_change_management,
          send: send
        });
        this.load();
        this.cancel(i);
        this.$bvToast.toast("Response berhasil di ubah", {
          title: "Success",
          variant: "success",
          solid: true
        });
      }
    },

    cancel(id) {
      var input = document.getElementById("response-change-form-" + id);
      var text = document.getElementById("response-change-text-" + id);

      input.classList.add("d-none");
      text.classList.remove("d-none");

      // button
      var edit = document.getElementById("response-change-edit-" + id);
      var save = document.getElementById("response-change-save-" + id);

      edit.classList.remove("d-none");
      save.classList.add("d-none");
      this.isEdit = false;
    }
  }
};
</script>
